#ifndef I2C_H
#define I2C_H

enum i2c_status_code_t {
	I2C_STATUS_MASK = 0b11111000,
	I2C_STATUS_START = 0x08,
	I2C_STATUS_REPEATED_START = 0x10,
	I2C_STATUS_SLA_W_ACK = 0x18,
	I2C_STATUS_SLA_W_NOT_ACK = 0x20,
	I2C_STATUS_DATA_W_ACK = 0x28,
	I2C_STATUS_DATA_W_NOT_ACK = 0x30,
	I2C_STATUS_ARBITRATION_LOST = 0x38,
	I2C_STATUS_SLA_R_ACK = 0x40,
	I2C_STATUS_SLA_R_NOT_ACK = 0x48,
	I2C_STATUS_DATA_R_ACK = 0x50,
	I2C_STATUS_DATA_R_NOT_ACK = 0x58,
};

// Initialise (and enable) the two-wire interface with a particular clock frequency.
void i2c_init(uint32_t frequency);

// Write a block of data to a two-wire device.
uint8_t i2c_write(uint8_t slave_address, uint8_t target_address, uint8_t* data, uint8_t length);

// Read a block of data from a two-wire device.
uint8_t i2c_read(uint8_t slave_address, uint8_t source_address, uint8_t* data, uint8_t length);

#endif