#include <stdint.h>
#include <avr/io.h>
#include <util/delay.h>

#include "i2c.h"

// Writes a single byte to the VGM sound chip.
void vgm_write(uint8_t value) {

	// Send START.
	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	
	// Send slave address.
	TWDR = 0x7E & 0xFE;
	TWCR = _BV(TWINT) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	
	// Send data
	TWDR = value;
	TWCR = _BV(TWINT) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	
	// Send STOP.
	TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTO);
	
	// HACK: Why is this required?
	_delay_us(100);

}

// Reads a single byte from the VGM sound chip.
uint8_t vgm_read(void) {

	// Send START.
	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	
	// Send slave address.
	TWDR = 0x7E | 0x01;
	TWCR = _BV(TWINT) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	
	// Receive data.
	TWCR = _BV(TWINT) | _BV(TWEN);
	while (!(TWCR & _BV(TWINT)));
	uint8_t value = TWDR;
	
	// Send STOP.
	TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWSTO);
	
	// Success!
	return value;
}