#ifndef Z80_H
#define Z80_H

#define Z80_DATA_PORT (PORTA)
#define Z80_DATA_DDR (DDRA)
#define Z80_DATA_PIN (PINA)

#define Z80_RESET_PORT (PORTC)
#define Z80_RESET_DDR (DDRC)
#define Z80_RESET_PIN (PINC)
#define Z80_RESET (7)

#define Z80_BUSREQ_PORT (PORTC)
#define Z80_BUSREQ_DDR (DDRC)
#define Z80_BUSREQ_PIN (PINC)
#define Z80_BUSREQ (6)

#define Z80_BUSACK_PORT (PORTC)
#define Z80_BUSACK_DDR (DDRC)
#define Z80_BUSACK_PIN (PINC)
#define Z80_BUSACK (5)

#define Z80_WR_PORT (PORTC)
#define Z80_WR_DDR (DDRC)
#define Z80_WR_PIN (PINC)
#define Z80_WR (4)

#define Z80_RD_PORT (PORTC)
#define Z80_RD_DDR (DDRC)
#define Z80_RD_PIN (PINC)
#define Z80_RD (3)

#define Z80_MREQ_PORT (PORTC)
#define Z80_MREQ_DDR (DDRC)
#define Z80_MREQ_PIN (PINC)
#define Z80_MREQ (2)

#define Z80_IORQ_PORT (PORTD)
#define Z80_IORQ_DDR (DDRD)
#define Z80_IORQ_PIN (PIND)
#define Z80_IORQ (7)

#define Z80_WAIT_RESET_PORT (PORTB)
#define Z80_WAIT_RESET_DDR (DDRB)
#define Z80_WAIT_RESET_PIN (PINB)
#define Z80_WAIT_RESET (1)

#define Z80_INT_PORT (PORTB)
#define Z80_INT_DDR (DDRB)
#define Z80_INT_PIN (PINB)
#define Z80_INT (0)

#define Z80_M1_PORT (PORTD)
#define Z80_M1_PIN (PIND)
#define Z80_M1_DDR (DDRD)
#define Z80_M1 (4)

// Initialise the Z80 utility routines.
void z80_init(void);

// Reset the Z80.
void z80_reset(void);

// Take control of the bus.
void z80_control_bus(void);

// Return control of the bus to the Z80.
void z80_release_bus(void);

// Clear the wait condition.
void z80_reset_wait(void);

// Clear the wait condition and take control of the bus.
void z80_reset_wait_control_bus(void);

#endif